package
{
	import flash.display.*;
	import flash.events.*;
	import flash.utils.*;
	import org.papervision3d.core.effects.view.ReflectionView;
	
	import com.as3dmod.*;
	import com.as3dmod.modifiers.*;
	import com.as3dmod.util.*;
	import com.as3dmod.plugins.pv3d.*;
	
	import org.papervision3d.objects.*
	import org.papervision3d.objects.primitives.*;
	import org.papervision3d.materials.*;
	import org.papervision3d.materials.utils.MaterialsList;
	import org.papervision3d.view.*;
	
	[SWF(width = "720", height = "480", frameRate = "60", backgroundColor = "#000000")]
	
	public class Main extends BasicView
	{
		private var bone      :Bend;
		private var bonePhase :Phase;
		private var obj3D  :DisplayObject3D;
		private var modifier  :ModifierStack;
		
		private var w:Twist;
		private var wph:Phase;
		
		public function Main()
		{
			stage.quality = StageQuality.LOW
			
			var materials:MaterialsList = new MaterialsList(
			{
				top    : new BitmapFileMaterial("side.png"),
				bottom : new BitmapFileMaterial("side.png"),
				front  : new BitmapFileMaterial("front.png"),
				back   : new BitmapFileMaterial("front.png"),
				left   : new BitmapFileMaterial("side.png"),
				right  : new BitmapFileMaterial("side.png")
			});
			obj3D = new Cube(materials, 500, 30, 500, 7, 7, 2);
			scene.addChild(obj3D);

			modifier = new ModifierStack(new LibraryPv3d(), obj3D);			
			w = new Twist(Math.PI / 2);
			wph = new Phase();
			modifier.addModifier(w);
			
			var floor:Plane = new Plane(new BitmapFileMaterial("floor.png"), 2000, 2000, 4, 4 );
			floor.rotationX = 90;
			floor.y = -500;
			scene.addChild(floor);
			
			startRendering();
			addEventListener(Event.ENTER_FRAME, loop);
		}
		
		protected function loop(event:Event = null):void
		{
			wph.value += 0.03;
			w.angle = Math.PI / 8 * wph.phasedValue;

			modifier.apply();
			
			obj3D.y = Math.sin(getTimer() / 500) * 50
			obj3D.yaw(1)
			
			camera.x += (Math.sin(mouseX / stage.stageWidth * 3 * Math.PI) * 1000 - camera.x) * .1;
			camera.z += (Math.cos(mouseX / stage.stageWidth * 3 * Math.PI) * 1000 - camera.z) * .1;
			camera.y += (mouseY / stage.stageHeight * 2000 - 500 - camera.y) * .05;
		}
	}	
}