package
{
	import flash.display.*;
	import flash.events.*;
	import flash.utils.*;
	
	import com.as3dmod.*;
	import com.as3dmod.modifiers.*;
	import com.as3dmod.util.*;
	import com.as3dmod.plugins.pv3d.*;
	
	import org.papervision3d.objects.*
	import org.papervision3d.objects.primitives.*;
	import org.papervision3d.materials.*;
	import org.papervision3d.view.*;
	
	[SWF(width = "720", height = "480", frameRate = "60", backgroundColor = "#000000")]
	
	public class Main extends BasicView
	{
		private var modifier     :ModifierStack;
		private var bend         :Bend;
		private var bendPhase    :Phase;
		
		private var obj3D        :DisplayObject3D;
		private var materialFlag :BitmapFileMaterial;
		private var materialWire :WireframeMaterial;
		
		public function Main()
		{
			stage.quality = StageQuality.LOW
			
			materialFlag = new BitmapFileMaterial("front.png")
			materialWire = new WireframeMaterial(0x0099FF)
			materialFlag.doubleSided = true;
			materialWire.doubleSided = true;
			obj3D = new Plane(materialFlag, 750, 750, 14, 14);
			obj3D.rotationX = 90
			scene.addChild(obj3D);

			modifier = new ModifierStack(new LibraryPv3d(), obj3D);
			var  per:Perlin = new Perlin(1.5);
			per.setFalloff(1, 0.5);
			modifier.addModifier(per);
			
			bend = new Bend(1, 1);
			bend.constraint = ModConstant.RIGHT;
			bendPhase = new Phase();
			modifier.addModifier(bend);
			
			var floor:Plane = new Plane(new BitmapFileMaterial("floor.png"), 2000, 2000, 4, 4 );
			floor.rotationX = 90;
			floor.y = -750;
			scene.addChild(floor);
			
			startRendering();
			
			stage.addEventListener(MouseEvent.MOUSE_DOWN, function(e:MouseEvent):void { obj3D.material = materialWire; } );
			stage.addEventListener(MouseEvent.MOUSE_UP, function(e:MouseEvent):void { obj3D.material = materialFlag; } );
		}
		
		protected override function onRenderTick(e:Event = null):void
		{
			bendPhase.value += 0.01;
			bend.force = bendPhase.phasedValue * 1.5
			modifier.apply();
			
			obj3D.x = Math.cos(getTimer() / 1000) * 300
			obj3D.y = Math.sin(getTimer() / 500) * 100
			
			camera.x += (Math.sin(mouseX / stage.stageWidth * 3 * Math.PI) * 1000 - camera.x) * .1;
			camera.z += (Math.cos(mouseX / stage.stageWidth * 3 * Math.PI) * 1000 - camera.z) * .1;
			camera.y += (mouseY / stage.stageHeight * 2000 - 500 - camera.y) * .05;
			
			super.onRenderTick(e);
		}
	}	
}