package
{
	import flash.display.*;
	import flash.events.*;
	
	import com.as3dmod.*;
	import com.as3dmod.modifiers.*;
	import com.as3dmod.util.*;
	import com.as3dmod.plugins.pv3d.*;
	
	import org.papervision3d.objects.*
	import org.papervision3d.objects.primitives.*;
	import org.papervision3d.materials.*;
	import org.papervision3d.materials.utils.*;
	import org.papervision3d.materials.shadematerials.*;
	import org.papervision3d.view.*;
	import org.papervision3d.lights.*;
	import org.papervision3d.core.math.*;
	import org.papervision3d.core.proto.*;
	
	[SWF(width = "720", height = "480", frameRate = "60", backgroundColor = "#000000")]
	
	public class Main extends BasicView
	{
		static private const SEGMENT_W:int = 20;
		static private const SEGMENT_H:int = 15;
		
		private var obj3D     :DisplayObject3D;
		private var planes    :Array;
		
		private var modifier  :ModifierStack;
		private var s         :Skew;
		private var sph       :Phase;
		
		public function Main()
		{
			stage.quality = StageQuality.LOW
			
			var i:int;
			var j:int;
			planes = [];
			var planeMat:BitmapFileMaterial = new BitmapFileMaterial("front.png");
			planeMat.doubleSided = true;
			for (i = 0; i < SEGMENT_W; i++ )
			{
				planes[i] = [];
				for (j = 0; j < SEGMENT_H; j++ )
				{
					planes[i][j] = new Plane(planeMat, 30, 30, 1, 1);
					scene.addChild(planes[i][j]);
				}
			}
			
			obj3D = new Cylinder(new WireframeMaterial(0x0099FF), 150, 1000, SEGMENT_W, SEGMENT_H, -1);
			obj3D.visible = false;
			scene.addChild(obj3D);

			modifier = new ModifierStack(new LibraryPv3d(), obj3D);
			s = new Skew(500);
			sph = new Phase();
			modifier.addModifier(s);
			
			var floor:Plane = new Plane(new BitmapFileMaterial("floor.png"), 2000, 2000, 4, 4 );
			floor.rotationX = 90;
			floor.y = -750;
			scene.addChild(floor);
			
			startRendering();
			
			stage.addEventListener(MouseEvent.MOUSE_DOWN, function(e:Event):void { obj3D.visible = true; } );
			stage.addEventListener(MouseEvent.MOUSE_UP, function(e:Event):void { obj3D.visible = false; } );
		}
		
		protected override function onRenderTick(e:Event = null):void
		{
			sph.value += 0.1;
			s.force = sph.phasedValue * 1000;
			modifier.apply();
			
			camera.x += (Math.sin(mouseX / stage.stageWidth * 3 * Math.PI) * 1000 - camera.x) * .1;
			camera.z += (Math.cos(mouseX / stage.stageWidth * 3 * Math.PI) * 1000 - camera.z) * .1;
			camera.y += (mouseY / stage.stageHeight * 2000 - 500 - camera.y) * .05;
			
			var points:Array = [];
			for each(var g:* in obj3D.geometry.vertices)
				points.push( { x:g.x, y:g.y, z:g.z } );
			
			for (var i:int = 0; i < planes.length; i++ )
			{
				for (var j:int = 0; j < planes[i].length; j++ )
				{
					var p:Object = points.shift();
					planes[i][j].x = p.x;
					planes[i][j].y = p.y;
					planes[i][j].z = p.z;
					planes[i][j].lookAt(camera);
				}
			}
			
			super.onRenderTick(e);
		}
	}	
}